﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace XamDataChartMinMax
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void xamDataChart1_Loaded(object sender, RoutedEventArgs e)
        {
            DataSample items = new DataSample();
            var sortedItems = items.OrderByDescending(item => item.X).ToArray();
            numericXAxis.MaximumValue = sortedItems[0].X * 1.1;
            numericXAxis.MinimumValue = sortedItems[sortedItems.Count() - 1].X * 0.8;
            sortedItems = items.OrderByDescending(item => item.Y).ToArray();
            numericYAxis.MaximumValue = sortedItems[0].Y * 1.1;
            numericYAxis.MinimumValue = sortedItems[sortedItems.Count() - 1].Y * 0.8;
        }
    }
    public class DataSample : DataCollection
    {
        public DataSample()
        {
            List<DataPoint> items = new List<DataPoint>
            {
                new DataPoint {X = 100, Y = 100},
                new DataPoint {X = 80, Y = 80},
                new DataPoint {X = 80, Y = 160},
                new DataPoint {X = 160, Y = 80},
                new DataPoint {X = 160, Y = 160},
                new DataPoint {X = 60, Y = 60},
                new DataPoint {X = 60, Y = 140},
                new DataPoint {X = 140, Y = 60},
                new DataPoint {X = 140, Y = 140},
                new DataPoint {X = 40, Y = 40},
                new DataPoint {X = 40, Y = 120},
                new DataPoint {X = 120, Y = 40},
                new DataPoint {X = 120, Y = 120},
                new DataPoint {X = 20, Y = 20},
                new DataPoint {X = 20, Y = 180},
                new DataPoint {X = 180, Y = 20},
                new DataPoint {X = 180, Y = 180}
            };

            var sortedItems = items.OrderByDescending(item => item.X).ToArray();
            for (int i = 0; i < sortedItems.Count(); i++)
            {

                sortedItems[i].Label = "Item " + (i + 1);
                this.Add(sortedItems[i]);
            }

        }
    }
          public class DataCollection : ObservableCollection<DataPoint>
    { }
    public class DataPoint : ObservableModel
    {

        #region Properties

        private double _y;
        public double Y
        {
            get { return _y; }
            set { if (_y == value) return; _y = value; OnPropertyChanged("Y"); }
        }

        private double _x;
        public double X
        {
            get { return _x; }
            set { if (_x == value) return; _x = value; OnPropertyChanged("X"); }
        }

        private string _label;
        public string Label
        {
            get { return _label; }
            set { if (_label == value) return; _label = value; OnPropertyChanged("Label"); }
        }

        #endregion

        public new string ToString()
        {
            return String.Format("X {0}, Y {1}, Radius {2}", X, Y);
        }

    }
    public abstract class ObservableModel : INotifyPropertyChanged
    {
        protected ObservableModel()
        {

        }

        #region INotifyPropertyChanged

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));
        }

        public void OnAsyncPropertyChanged(string propertyName)
        {
            //if (PropertyChanged != null)
            //{
            //    System.Deployment.Current.Dispatcher.BeginInvoke(() =>
            //    {
            //        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            //    });
            //}
        }
        #endregion
    }

}
